/*
 * JBoss, Home of Professional Open Source
 * Copyright 2016, Red Hat, Inc., and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.jboss.cdi.tck.tests.extensions.configurators.observerMethod;

import java.util.concurrent.atomic.AtomicBoolean;
import jakarta.enterprise.context.ApplicationScoped;
import jakarta.enterprise.event.Observes;

@ApplicationScoped
public class FruitObserver {

    public static AtomicBoolean melonObserverNotified = new AtomicBoolean(false);
    public static AtomicBoolean peachObserverNotified = new AtomicBoolean(false);
    public static AtomicBoolean bananaObserverNotified = new AtomicBoolean(false);
    public static AtomicBoolean pearObserverNotified = new AtomicBoolean(false);


    public void observesPear(@Observes Pear pear) {
        pearObserverNotified.set(true);
    }

    public void observesOrange(@Observes @Ripe Orange orange) {
    }

    public void observesOrange(@Observes Pineapple pineapple) {
    }

    public void observesBanana(@Observes Fruit banana) {
        bananaObserverNotified.set(true);
    }

    public void observesMelon(@Observes Melon melon) {
        melonObserverNotified.set(true);
    }

    public void observesPeach(@Observes Peach peach) {
        peachObserverNotified.set(true);
    }

    public void observesKiwi(@Observes @Ripe Kiwi kiwi){

    }
}
